﻿using System;
using System.Web.Mvc;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.MvcEdition;

namespace CSharp_HowDoISamples
{
    public partial class InteractiveOverlaysController : Controller
    {
        public ActionResult AddAMarker()
        {
            Map map = new Map("Map1",
                new System.Web.UI.WebControls.Unit(500),
                new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage));

            map.MapUnit = GeographyUnit.DecimalDegree;
            map.CurrentExtent = new RectangleShape(-125, 72, 50, -46);

            map.MapBackground = new BackgroundLayer(new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF")));
            map.CustomOverlays.Add(new WorldMapKitWmsWebOverlay());

            SimpleMarkerOverlay markerOverlay = new SimpleMarkerOverlay("SimpleMarkerOverlay");
            markerOverlay.DragMode = MarkerDragMode.Drag;
            markerOverlay.IsBaseOverlay = false;
            markerOverlay.OnClientMarkerDragged = "_ClientOnClientMarkerDragged";

            map.CustomOverlays.Add(markerOverlay);
            return View(map);
        }

        [MapActionFilter]
        public void AddMarker(Map map, GeoCollection<object> args)
        {
            string markerId = args["markerId"].ToString();
            double x = Convert.ToDouble(args["x"]);
            double y = Convert.ToDouble(args["y"]);


            SimpleMarkerOverlay markerOverlay = map.CustomOverlays["SimpleMarkerOverlay"] as SimpleMarkerOverlay;
            markerOverlay.DragMode = MarkerDragMode.Drag;
            markerOverlay.OnClientMarkerDragged = "_ClientOnClientMarkerDragged"; // this would not work.
            markerOverlay.Markers.Clear();
            markerOverlay.Markers.Add(new Marker(new PointShape(x, y)));
        }
    }
}